;
; BLITZ BASS INCLUDE - V1.00 - Written by Rob Hutchinson 2002 for Lab[AU] - http://www.lab-au.com/
; -------------------------------------------------------------------------------------------------
; Access to the bass.dll - blitzbass.dll wrapper DLL required.
;
; MISSING/NON-REQUIRED FUNCTIONS:
;  - BASS_SetCLSID() - Uses default. + Blitz cant really pass the 128bit integer..
;  - BASS_GetDSoundObject() - Pointless..
;  - BASS_StreamCreate() - Not sure about the callback/affect in blitz, will try and add this if needed..
;  - BASS_ChannelSetDSP() - Callback plop.. (not sure I could implement these easily enuff.. Is there really any need tho??)
;  - BASS_ChannelRemoveDSP()
;  - BASS_ChannelSetSync()
;  - BASS_ChannelRemoveSync()
;

Global sBlitzBASSDLLCommandPrefixA101B6$ = ""
Global sBlitzBASSDLLNameA101B6$ = "blitzbass"
Global sBlitzBASSDLLVersionA101B6$ = "1.00"

; ----------------------------------------------------------------------------------------------
; BASS Functions
; ----------------------------------------------------------------------------------------------
Function sBASS_FUNCTIONS________() : End Function

Function BASS_ErrorGetCode()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ErrorGetCode_Wrap")
End Function

Function BASS_Free()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Free_Wrap")
End Function

Function BASS_GetCPU#()
	Local mBankOut,iResult#
	
	mBankOut = CreateBank(4)
		
	CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_GetCPU_Wrap",0,mBankOut)
	iResult# = PeekFloat(mBankOut,0)
	
	FreeBank mBankOut
	Return iResult#
End Function

Function BASS_GetDeviceDescription$(iCount,iContextBuffer = 1024)
	Local mBankIn,iResult,sResult$
	
	mBankIn  = CreateBank(4)
	mBankOut = CreateBank(iContextBuffer)
	PokeInt mBankIn,0,iCount

	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_GetDeviceDescription_Wrap",mBankIn,mBankOut)
	If iResult
		sResult$ = BASSPeekString(mBankOut)
	EndIf
	
	FreeBank mBankIn
	FreeBank mBankOut

	Return sResult$
End Function

Const BASS_GETVOLUME_MUSIC  = 0
Const BASS_GETVOLUME_SAMPLE = 1
Const BASS_GETVOLUME_STREAM = 2

Function BASS_GetGlobalVolumes(iVolumeMeter)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iVolumeMeter

	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_GetGlobalVolumes_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Const BASS_GETINFO_FLAGS         = 1
Const BASS_GETINFO_HWMEMTOTAL    = 2
Const BASS_GETINFO_HWMEMFREE     = 3
Const BASS_GETINFO_FREESAMPLES   = 4
Const BASS_GETINFO_FREE3DSAMPLES = 5
Const BASS_GETINFO_MINRATE       = 6
Const BASS_GETINFO_MAXRATE       = 7
Const BASS_GETINFO_EAXCAPABLE    = 8
Const BASS_GETINFO_A3DVERSION    = 9
Const BASS_GETINFO_DIRECTXVER    = 10
Const BASS_GETINFO_LATENCY       = 11

Function BASS_GetInfo(iInfoStub)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iInfoStub
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_GetInfo_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_GetVersion()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_GetVersion_Wrap")
End Function

; Master volume this one is..
Function BASS_GetVolume()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_GetVolume_Wrap")
End Function

Function BASS_Init(iDevice,iFreq,iFlags,hWnd)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(16)
	PokeInt mBankIn,0,iDevice
	PokeInt mBankIn,4,iFreq
	PokeInt mBankIn,8,iFlags
	PokeInt mBankIn,12,hWnd

	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Init_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_Pause()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Pause_Wrap")
End Function

Function BASS_SetBufferLength#(fNewBufLen#)
	Local mBankIn,iResult,fResult#
	
	mBankOut = CreateBank(4)
	mBankIn  = CreateBank(4)
	PokeFloat mBankIn,0,fNewBufLen#
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SetBufferLength_Wrap",mBankIn,mBankOut)
	fResult# = PeekFloat(mBankOut,0)
	
	FreeBank mBankIn
	FreeBank mBankOut
	Return fResult#
End Function

Function BASS_SetGlobalVolumes(iMusicVol,iSampleVol,iStreamVol)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(12)
	PokeInt mBankIn,0,iMusicVol
	PokeInt mBankIn,4,iSampleVol
	PokeInt mBankIn,8,iStreamVol
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SetGlobalVolumes_Wrap",mBankIn)
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_SetLogCurves(bVolume,bPan)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,bVolume
	PokeInt mBankIn,4,bPan
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SetLogCurves_Wrap",mBankIn)
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_SetVolume(iVolume)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iVolume
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SetVolume_Wrap",mBankIn)
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_Start()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Start_Wrap")
End Function

Function BASS_Stop()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Stop_Wrap")
End Function

Function BASS_Update()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Update_Wrap")
End Function

; Added wrapper... Gets whether or not a device is there (available)..
Function BASS_GetDeviceAvailable(iCount)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iCount

	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_GetDeviceAvailable",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

; ----------------------------------------------------------------------------------------------
; 3D/EAX Functions
; ----------------------------------------------------------------------------------------------
Function sEAX3D_FUNCTIONS_______() : End Function

Function BASS_Apply3D()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Apply3D_Wrap")
End Function

Const BASS_GET3DFACTORS_DISTANCE = 0
Const BASS_GET3DFACTORS_ROLLOFF  = 1
Const BASS_GET3DFACTORS_DOPPLER  = 2

Function BASS_Get3DFactors#(iFactor)
	Local mBankIn,iResult,fResult#
	
	mBankOut = CreateBank(4)
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iFactor
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Get3DFactors_Wrap",mBankIn,mBankOut)
	If iResult
		fResult# = PeekFloat(mBankOut,0)
	EndIf
	
	FreeBank mBankIn
	FreeBank mBankOut
	Return fResult#
End Function

Const BASS_GET3DPOS_POSX    = 0
Const BASS_GET3DPOS_POSY    = 1
Const BASS_GET3DPOS_POSZ    = 2
Const BASS_GET3DPOS_VELX    = 3
Const BASS_GET3DPOS_VELY    = 4
Const BASS_GET3DPOS_VELZ    = 5
Const BASS_GET3DPOS_FRONTX  = 6
Const BASS_GET3DPOS_FRONTY  = 7
Const BASS_GET3DPOS_FRONTZ  = 8
Const BASS_GET3DPOS_TOPX    = 9
Const BASS_GET3DPOS_TOPY    = 10
Const BASS_GET3DPOS_TOPZ    = 11

Function BASS_Get3DPosition#(iValueWanted)
	Local mBankIn,iResult,fResult#
	
	mBankOut = CreateBank(4)
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iValueWanted
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Get3DPosition_Wrap",mBankIn,mBankOut)
	If iResult Then fResult# = PeekFloat(mBankOut,0)
	
	FreeBank mBankIn
	FreeBank mBankOut
	Return fResult#
End Function

Const BASS_GETEAX_ENV    = 0
Const BASS_GETEAX_VOLUME = 1
Const BASS_GETEAX_DECAY  = 2
Const BASS_GETEAX_DAMP   = 3

Function BASS_GetEAXParameters$(iParam)
	Local mBankIn,iResult,fResult#
	
	mBankOut = CreateBank(4)
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iParam
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_GetEAXParameters_Wrap",mBankIn,mBankOut)
	FreeBank mBankIn

	If iParam = BASS_GETEAX_ENV
		il = PeekInt(mBankOut,0)
		FreeBank mBankOut
		Return il
	Else
		fl# = PeekFloat(mBankOut,0)
		FreeBank mBankOut
		Return fl#
	EndIf
End Function

Function BASS_Set3DAlgorithm(iAlgo)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iAlgo
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Set3DAlgorithm_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_Set3DFactors(fDist#,fRoll#,fDopp#)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(12)
	PokeFloat mBankIn,0,fDist#
	PokeFloat mBankIn,4,fRoll#
	PokeFloat mBankIn,8,fDopp#
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Set3DFactors_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_Set3DPosition(fPosX#,fPosY#,fPosZ#, fVelX#,fVelY#,fVelZ#, fFrontX#,fFrontY#,fFrontZ#, fTopX#,ftopY#,fTopZ#)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(12 * 4)
	PokeFloat mBankIn,0,fPosX#
	PokeFloat mBankIn,4,fPosY#
	PokeFloat mBankIn,8,fPosZ#
	
	PokeFloat mBankIn,12,fVelX#
	PokeFloat mBankIn,16,fVelY#
	PokeFloat mBankIn,20,fVelZ#
	
	PokeFloat mBankIn,24,fFrontX#
	PokeFloat mBankIn,28,fFrontY#
	PokeFloat mBankIn,32,fFrontZ#
	
	PokeFloat mBankIn,36,fTopX#
	PokeFloat mBankIn,40,ftopY#
	PokeFloat mBankIn,44,fTopZ#
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_Set3DPosition_Wrap",mBankIn)
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_SetEAXParameters(iEnv,fVol#,fDecay#,fDamp#)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(16)
	PokeInt mBankIn,0,iEnv
	PokeFloat mBankIn,4,fVol#
	PokeFloat mBankIn,8,fDecay#
	PokeFloat mBankIn,12,fDamp#
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SetEAXParameters_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function


; ----------------------------------------------------------------------------------------------
; Recording Functions
; ----------------------------------------------------------------------------------------------
Function sRECORDING_FUNCTIONS____() : End Function

Const RECORDCHAN = 1

Function BASS_RecordAndPlay()
	CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_RecordAndPlay_Wrap")
End Function

Function BASS_RecordAndMute()
	CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_RecordAndMute_Wrap")
End Function



Function BASS_RecordPlayLocation(posX#,posY#,posZ#, orientX#, orientY#, orientZ#)
	Local mBankIn
	
	mBankIn  = CreateBank(24)
	
	PokeFloat mBankIn,0,posX#
	PokeFloat mBankIn,4,posY#
	PokeFloat mBankIn,8,posZ#

	PokeFloat mBankIn,12,orientX#
	PokeFloat mBankIn,16,orientY#
	PokeFloat mBankIn,20,orientZ#

	CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_RecordPlayLocation_Wrap", mBankIn)
End Function


Function BASS_RecordStop()
	CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_RecordStop_Wrap")
End Function



; ----------------------------------------------------------------------------------------------
; CD Audio Functions
; ----------------------------------------------------------------------------------------------
Function sCDAUDIO_FUNCTIONS____() : End Function

Function BASS_CDFree()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_CDFree_Wrap")
End Function

Function BASS_CDGetID$(iID,iIDBufferSize = 512)
	Local mBankIn,iResult,sResult$
	
	mBankIn  = CreateBank(4)
	mBankOut = CreateBank(iIDBufferSize)
	PokeInt mBankIn,0,iID
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_CDGetID_Wrap",mBankIn,mBankOut)
	If iResult
		sResult$ = BASSPeekString(mBankOut)
	EndIf
	
	FreeBank mBankIn
	FreeBank mBankOut
	Return sResult$
End Function

Function BASS_CDGetTrackLength(iTrack)
	Local mBankIn,iTrackLen
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iTrack
		
	iTrackLen = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_CDGetTrackLength_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iTrackLen
End Function

Function BASS_CDGetTracks()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_CDGetTracks_Wrap")
End Function

Function BASS_CDInDrive()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_CDInDrive_Wrap")
End Function



Function BASS_CDInit(sDrive$ = "")
	Local mBankIn,iResult

	mBankIn  = CreateBank(Len(sDrive$) + 1)
	BASSPokeString mBankIn,sDrive$

	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_CDInit_Wrap",mBankIn)
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_CDPlay(iTrack,bLoop = False,bWait = False)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(12)
	PokeInt mBankIn,0,iTrack
	PokeInt mBankIn,4,bLoop
	PokeInt mBankIn,8,bWait
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_CDPlay_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

; ----------------------------------------------------------------------------------------------
; Sample Functions
; ----------------------------------------------------------------------------------------------
Function sSAMPLE_FUNCTIONS______() : End Function

Function BASS_SampleCreate(mBankSound,iFreq,iMax,iFlags)
	Local mBankOut,iResult
	
	mBankOut  = CreateBank(12)
	PokeInt mBankOut,0,iFreq
	PokeInt mBankOut,4,iMax
	PokeInt mBankOut,8,iFlags
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SampleCreate_Wrap",mBankSound,mBankOut)
	
	FreeBank mBankOut
	Return iResult
End Function

Function BASS_SampleCreateDone()
	Return CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SampleCreateDone_Wrap",mBankSound,mBankOut)
End Function

Function BASS_SampleFree(iSampleHandle)
	Local mBankIn,iChannelHandle
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iSampleHandle
	
	iChannelHandle = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SampleFree_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iChannelHandle
End Function

; Returns - A bank with info ala SAMPLE_INFO structure in bass. Peek them out with PeekInt() and PeekFloat()
Function BASS_SampleGetInfo(iSampleHandle)
	Local mBankIn,iChannelHandle
	
	mBankIn  = CreateBank(4)
	mBankOut = CreateBank(4 * 15)
	PokeInt mBankIn,0,iSampleHandle
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SampleGetInfo_Wrap",mBankIn,mBankOut)
	FreeBank mBankIn

	If iResult
		Return mBankOut
	Else
		FreeBank mBankOut
		Return 0
	EndIf
End Function

Function BASS_SampleLoad(bMem,sFileName$,iOffset,iLength,iMaxPlaybacks,iFlags)
	Local mBankIn,iSampleHandle,iBankSize
	
	iBankSize = Len(sFileName$) + 21
	mBankIn   = CreateBank(iBankSize)
	PokeInt mBankIn,0,bMem
	PokeInt mBankIn,4,iOffset
	PokeInt mBankIn,8,iLength
	PokeInt mBankIn,12,iMaxPlaybacks
	PokeInt mBankIn,16,iFlags
	BASSPokeString mBankIn,sFileName$,20

	iSampleHandle = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SampleLoad_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iSampleHandle
End Function

Function BASS_SamplePlay(iSampleHandle)
	Local mBankIn,iChannelHandle
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iSampleHandle
	
	iChannelHandle = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SamplePlay_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iChannelHandle
End Function

Function BASS_SamplePlay3D(iSampleHandle, fPosX#,fPosY#,fPosZ#, fOrientX#,fOrientY#,fOrientZ#, fVelX#,fVelY#,fVelZ#)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(10 * 4)
	PokeInt mBankIn,0,iSampleHandle
	
	PokeFloat mBankIn,4,fPosX#
	PokeFloat mBankIn,8,fPosY#
	PokeFloat mBankIn,12,fPosZ#

	PokeFloat mBankIn,16,fOrientX#
	PokeFloat mBankIn,20,fOrientY#
	PokeFloat mBankIn,24,fOrientZ#
	
	PokeFloat mBankIn,28,fVelX#
	PokeFloat mBankIn,32,fVelY#
	PokeFloat mBankIn,36,fVelZ#
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SamplePlay3D_Wrap",mBankIn)
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_SamplePlay3DEx(iSampleHandle,iStart,iFreq,iVolume,bLoop, fPosX#,fPosY#,fPosZ#, fOrientX#,fOrientY#,fOrientZ#, fVelX#,fVelY#,fVelZ#)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(14 * 4)
	PokeInt mBankIn,0,iSampleHandle
	PokeInt mBankIn,4,iStart
	PokeInt mBankIn,8,iFreq
	PokeInt mBankIn,12,iVolume
	PokeInt mBankIn,16,bLoop
	
	PokeFloat mBankIn,20,fPosX#
	PokeFloat mBankIn,24,fPosY#
	PokeFloat mBankIn,28,fPosZ#

	PokeFloat mBankIn,32,fOrientX#
	PokeFloat mBankIn,36,fOrientY#
	PokeFloat mBankIn,40,fOrientZ#
	
	PokeFloat mBankIn,44,fVelX#
	PokeFloat mBankIn,48,fVelY#
	PokeFloat mBankIn,52,fVelZ#
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SamplePlay3DEx_Wrap",mBankIn)
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_SamplePlayEx(iSampleHandle,iStart,iFreq,iVolume,iPan,bLoop)
	Local mBankIn,iChannelHandle
	
	mBankIn  = CreateBank(24)
	PokeInt mBankIn,0,iSampleHandle
	PokeInt mBankIn,4,iStart
	PokeInt mBankIn,8,iFreq
	PokeInt mBankIn,12,iVolume
	PokeInt mBankIn,16,iPan
	PokeInt mBankIn,20,bLoop
		
	iChannelHandle = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SamplePlayEx_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iChannelHandle
End Function

Function BASS_SampleSetInfo(iSampleHandle,mBankInfo)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iSampleHandle

	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SampleSetInfo_Wrap",mBankIn,mBankInfo)
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_SampleStop(iSampleHandle)
	Local mBankIn,iChannelHandle
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iSampleHandle
	
	iChannelHandle = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SampleFree_Stop",mBankIn)
	
	FreeBank mBankIn
	Return iChannelHandle
End Function

; ----------------------------------------------------------------------------------------------
; Stream Functions
; ----------------------------------------------------------------------------------------------
Function sSTREAM_FUNCTIONS_____() : End Function

Function BASS_StreamCreateFile(bMem,sFileName$,iOffset,iLength,iFlags)
	Local mBankIn,iStreamHandle,iBankSize
	
	iBankSize = Len(sFileName$) + 17
	mBankIn   = CreateBank(iBankSize)
	PokeInt mBankIn,0,bMem
	PokeInt mBankIn,4,iOffset
	PokeInt mBankIn,8,iLength
	PokeInt mBankIn,12,iFlags
	BASSPokeString mBankIn,sFileName$,16

	iStreamHandle = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_StreamCreateFile_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iStreamHandle
End Function

Function BASS_StreamCreateURL(sURL$,iOffset,iFlags,sSave$ = "")
	Local mBankIn,iStream,iBankSize,iBankOffset = 0
	
	iBankSize = Len(sURL$) + 1 + Len(sSave$) + 1 + 8
	mBankIn  = CreateBank(iBankSize)
	BASSPokeString(mBankIn,sURL$,iBankOffset)
	iBankOffset = iBankOffset + Len(sURL$) + 1
	BASSPokeString(mBankIn,sSave$,iBankOffset)
	iBankOffset = iBankOffset + Len(sSave$) + 1
	PokeInt mBankIn,iBankOffset,iOffset
	iBankOffset = iBankOffset + 4
	PokeInt mBankIn,iBankOffset,iFlags
		
	iStream = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_StreamCreateURL_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iStream
End Function

Function BASS_StreamFree(iStreamHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iStreamHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_StreamFree_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_StreamGetFilePosition(iStreamHandle,iMode)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iStreamHandle
	PokeInt mBankIn,4,iMode
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_StreamGetFilePosition_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_StreamGetLength(iStreamHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iStreamHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_StreamGetLength_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

; ///// NOT WORKING YET!!
Function BASS_StreamGetTags(iStreamHandle,iTags,iTagBuffer = 4096)
	Local mBankIn,iResult,mBankOut
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iStreamHandle
	PokeInt mBankIn,4,iTags
	mBankOut = CreateBank(iTagBuffer)
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_StreamGetTags_Wrap",mBankIn,mBankOut)
		
	FreeBank mBankIn
	Return mBankOut
End Function

Function BASS_StreamPlay(iStreamHandle,bFlush = False,iFlags = 0)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(12)
	PokeInt mBankIn,0,iStreamHandle
	PokeInt mBankIn,4,bFlush
	PokeInt mBankIn,8,iFlags
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_StreamPlay_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_StreamPreBuf(iStreamHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iStreamHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_StreamPreBuf_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

; ----------------------------------------------------------------------------------------------
; MOD/3 Music Functions
; ----------------------------------------------------------------------------------------------
Function sMUSIC_FUNCTIONS_______() : End Function

Function BASS_MusicFree(iMusicHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iMusicHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicFree_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_MusicGetChannelVol(iMusicHandle,iChannel)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iMusicHandle
	PokeInt mBankIn,4,iChannel
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicGetChannelVol_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_MusicGetLength(iMusicHandle,bPlayLen)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iMusicHandle
	PokeInt mBankIn,4,bPlayLen
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicGetLength_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_MusicGetName$(iMusicHandle,iOutBufferLen = 1024)
	Local mBankIn,iResult,sResult$
	
	mBankIn  = CreateBank(4)
	mBankOut = CreateBank(iOutBufferLen)
	PokeInt mBankIn,0,iMusicHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicGetName_Wrap",mBankIn)
	If iResult <> 0 Then sResult$ = BASSPeekString(mBankOut)	

	FreeBank mBankIn
	FreeBank mBankOut
	Return sResult$
End Function

Function BASS_MusicLoad(bMem,sFileName$,iOffset,iLength,iFlags)
	Local mBankIn,iMusicHandle,iBankSize
	
	iBankSize = Len(sFileName$) + 17
	mBankIn   = CreateBank(iBankSize)
	PokeInt mBankIn,0,bMem
	PokeInt mBankIn,4,iOffset
	PokeInt mBankIn,8,iLength
	PokeInt mBankIn,12,iFlags
	BASSPokeString mBankIn,sFileName$,16

	iMusicHandle = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicLoad_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iMusicHandle
End Function

Function BASS_MusicPlay(iMusicHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iMusicHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicPlay_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_MusicPlayEx(iMusicHandle,iPosition,iFlags,bReset)
	Local mBankIn,iResult
	
	mBankIn = CreateBank(16)
	PokeInt mBankIn,0,iMusicHandle
	PokeInt mBankIn,4,iPosition
	PokeInt mBankIn,8,iFlags
	PokeInt mBankIn,12,bReset

	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicPlayEx_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_MusicPreBuf(iMusicHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iMusicHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicPreBuf_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_MusicSetAmplify(iMusicHandle,iAmp)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iMusicHandle
	PokeInt mBankIn,4,iAmp
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicSetAmplify_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_MusicSetChannelVol(iMusicHandle,iChannel,iVolume = 100)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(12)
	PokeInt mBankIn,0,iMusicHandle
	PokeInt mBankIn,4,iChannel
	PokeInt mBankIn,8,iVolume
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicSetChannelVol_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_MusicSetPanSep(iMusicHandle,iPan)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iMusicHandle
	PokeInt mBankIn,4,iPan
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicSetPanSep_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_MusicSetPositionScaler(iMusicHandle,iScaler)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iMusicHandle
	PokeInt mBankIn,4,iScaler
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_MusicSetPositionScaler_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

; ----------------------------------------------------------------------------------------------
; Channel Functions
; ----------------------------------------------------------------------------------------------
Function sCHANNEL_FUNCTIONS_____() : End Function

Function BASS_ChannelBytes2Seconds#(iHandle,iPos)
	Local mBankIn,mBankOut,iResult#

	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	PokeInt mBankIn,4,iPos
		
	mBankOut = CreateBank(4)
		
	CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelBytes2Seconds_Wrap",mBankIn,mBankOut)
	iResult# = PeekFloat(mBankOut,0)
	
	FreeBank mBankOut
	FreeBank mBankIn
	Return iResult#
End Function

Const BASS_GETATTRIB3D_MODE   = 0
Const BASS_GETATTRIB3D_MIN    = 1
Const BASS_GETATTRIB3D_MAX    = 2
Const BASS_GETATTRIB3D_IANGLE = 3
Const BASS_GETATTRIB3D_OANGLE = 4
Const BASS_GETATTRIB3D_OUTVOL = 5

Function BASS_ChannelGet3DAttributes$(iHandle,iAttrib)
	Local mBankIn,mBankOut,sResult$

	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	PokeInt mBankIn,4,iAttrib
		
	mBankOut = CreateBank(4)
		
	CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelGet3DAttributes_Wrap",mBankIn,mBankOut)
	Select iAttrib
		Case BASS_GETATTRIB3D_MODE,BASS_GETATTRIB3D_IANGLE,BASS_GETATTRIB3D_OANGLE,BASS_GETATTRIB3D_OUTVOL
			sResult$ = PeekInt(mBankOut,0)
		Case BASS_GETATTRIB3D_MIN,BASS_GETATTRIB3D_MAX
			sResult$ = PeekFloat(mBankOut,0)		
	End Select
	
	FreeBank mBankOut
	FreeBank mBankIn
	Return iResult#
End Function

Const BASS_CHANNELGET3DPOS_POS_X    = 1
Const BASS_CHANNELGET3DPOS_POS_Y    = 2
Const BASS_CHANNELGET3DPOS_POS_Z    = 3
Const BASS_CHANNELGET3DPOS_ORIENT_X = 4
Const BASS_CHANNELGET3DPOS_ORIENT_Y = 5
Const BASS_CHANNELGET3DPOS_ORIENT_Z = 6
Const BASS_CHANNELGET3DPOS_VEL_X    = 7
Const BASS_CHANNELGET3DPOS_VEL_Y    = 8
Const BASS_CHANNELGET3DPOS_VEL_Z    = 9

Function BASS_ChannelGet3DPosition#(iHandle,iAttribGet)
	Local mBankIn,mBankOut,fResult#

	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	PokeInt mBankIn,4,iAttribGet
		
	mBankOut = CreateBank(4)
		
	If CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelGet3DPosition_Wrap",mBankIn,mBankOut)
		fResult# = PeekFloat(mBankOut,0)
	EndIf
	
	FreeBank mBankOut
	FreeBank mBankIn
	Return fResult#
End Function

Const BASS_CHANNELGETATTRIBS_FREQ   = 1
Const BASS_CHANNELGETATTRIBS_VOLUME = 2
Const BASS_CHANNELGETATTRIBS_PAN    = 3

Function BASS_ChannelGetAttributes(iHandle,iAttribGet)
	Local mBankIn,mBankOut,iResult

	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	PokeInt mBankIn,4,iAttribGet
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelGetAttributes_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelGetData(iHandle,iBufferSize)
	Local mBankIn,iResult,iBankSize
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	Select iBufferSize
		Case BASS_DATA_FFT512
			iBankSize = (256 * 4) + 4
		Case BASS_DATA_FFT1024
			iBankSize = (512 * 4) + 4
        Case BASS_DATA_FFT2048
			iBankSize = (1024 * 4) + 4
		Default
			iBankSize = iBufferSize
	End Select

	PokeInt mBankIn,4,iBufferSize
	mBankOut = CreateBank(iBankSize)
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelGetData_Wrap",mBankIn,mBankOut)
	FreeBank mBankIn

	Return mBankOut
End Function

Function BASS_ChannelGetEAXMix#(iHandle)
	Local mBankIn,mBankOut,fResult#

	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iHandle
		
	mBankOut = CreateBank(4)
		
	If CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelGetEAXMix_Wrap",mBankIn,mBankOut)
		fResult# = PeekFloat(mBankOut,0)
	EndIf
	
	FreeBank mBankOut
	FreeBank mBankIn
	Return fResult#
End Function

Function BASS_ChannelGetFlags(iHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelGetFlags_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelGetLevel(iHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelGetLevel_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelGetPosition(iHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelGetPosition_Wrap",mBankIn)

	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelIsActive(iHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelIsActive_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelPause(iHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelPause_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelRemoveFX(iHandle,iHFX)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	PokeInt mBankIn,4,iHFX
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelRemoveFX_Wrap",mBankIn)

	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelRemoveLink(iHandle,iChannel)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	PokeInt mBankIn,4,iChannel
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelRemoveLink_Wrap",mBankIn)

	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelResume(iHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelResume_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelSeconds2Bytes(iHandle,fPos#)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	PokeFloat mBankIn,4,fPos#
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelSeconds2Bytes_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelSet3DAttributes(iHandle,iMode,fMin#,fMax#,iIAngle,iOAngle,iOutVol)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(28)
	PokeInt mBankIn,0,iHandle
	PokeInt mBankIn,4,iMode
	PokeFloat mBankIn,8,fMin#
	PokeFloat mBankIn,12,fMax#
	PokeInt mBankIn,16,iIAngle
	PokeInt mBankIn,20,iOAngle
	PokeInt mBankIn,24,iOutVol
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelSet3DAttributes_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelSet3DPosition(iHandle, fPosX#,fPosY#,fPosZ#, fOrientX#,fOrientY#,fOrientZ#, fVelX#,fVelY#,fVelZ#)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(9 * 4)
	PokeFloat mBankIn,0,fPosX#
	PokeFloat mBankIn,4,fPosY#
	PokeFloat mBankIn,8,fPosZ#
	
	PokeFloat mBankIn,12,fOrientX#
	PokeFloat mBankIn,16,fOrientY#
	PokeFloat mBankIn,20,fOrientZ#
	
	PokeFloat mBankIn,24,fVelX#
	PokeFloat mBankIn,28,fVelY#
	PokeFloat mBankIn,32,fVelZ#

	mBankOut = CreateBank(4)
	PokeInt mBankOut,0,iHandle
	
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelSet3DPosition_Wrap",mBankIn,mBankOut)

	FreeBank mBankIn
	FreeBank mBankOut
	Return iResult
End Function

Function BASS_ChannelSetAttributes(iHandle,iFreq,iVolume,iPan)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(16)
	PokeInt mBankIn,0,iHandle
	PokeInt mBankIn,4,iFreq
	PokeInt mBankIn,8,iVolume
	PokeInt mBankIn,12,iPan

	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelSetAttributes_Wrap",mBankIn)

	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelSetEAXMix(iHandle,fMix#)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	PokeFloat mBankIn,4,fMix#
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelSetEAXMix_Wrap",mBankIn)

	FreeBank mBankIn
	Return iResult
End Function

; Returns a HFX to pass to BASS_FXSetParameters()
Function BASS_ChannelSetFX(iHandle,iFXType)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	PokeInt mBankIn,4,iFXType
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelSetFX_Wrap",mBankIn)

	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelSetLink(iHandle,iChannel)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	PokeInt mBankIn,4,iChannel
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelSetLink_Wrap",mBankIn)

	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelSetPosition(iHandle,iPosition)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(8)
	PokeInt mBankIn,0,iHandle
	PokeInt mBankIn,4,iPosition
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelSetPosition_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_ChannelStop(iHandle)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iHandle
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_ChannelStop_Wrap",mBankIn)
	
	FreeBank mBankIn
	Return iResult
End Function

; ----------------------------------------------------------------------------------------------
; FX Functions
; ----------------------------------------------------------------------------------------------
Function sFX_FUNCTIONS___________() : End Function

; You need to setup the bank that the params are set from/gotten from yourself with these
; following 2 commands. Make sure that the bank is big enough for the information or you you
; will crash blitz straight out...
Function BASS_FXGetParameters(iHFX,mParamsBank)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iHFX
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_FXGetParameters_Wrap",mBankIn,mParamsBank)
	
	FreeBank mBankIn
	Return iResult
End Function

Function BASS_FXSetParameters(iHFX,mParamsBank)
	Local mBankIn,iResult
	
	mBankIn  = CreateBank(4)
	PokeInt mBankIn,0,iHFX
		
	iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_FXSetParameters_Wrap",mBankIn,mParamsBank)
	
	FreeBank mBankIn
	Return iResult
End Function

; Instead of using the above 2 commands directly, you should only really need to use the 
; following commands for channel FX... See bass docs for the type syntax
Function BASS_FXCHORUS(iHFX, fWetDryMix#,fDepth#,fFeedback#,fFrequency#,iWaveform,fDelay#,iPhase)
	Local mBankOut,iResult
	
	mBankOut = CreateBank(4 * 7)
	PokeFloat mBankOut,0,fWetDryMix#
	PokeFloat mBankOut,4,fDepth#
	PokeFloat mBankOut,8,fFeedback#
	PokeFloat mBankOut,12,fFrequency#
	PokeInt   mBankOut,16,iWaveform
	PokeFloat mBankOut,20,fDelay#
	PokeInt   mBankOut,24,iPhase
		
	iResult = BASS_FXSetParameters(iHFX,mBankOut)
	
	FreeBank mBankOut
	Return iResult
End Function

Function BASS_FXCOMPRESSOR(iHFX, fGain#,fAttack#,fRelease#,fThreshold#,fRatio#,fPredelay#)
	Local mBankOut,iResult
	
	mBankOut = CreateBank(4 * 6)
	PokeFloat mBankOut,0,fGain#
	PokeFloat mBankOut,4,fAttack#
	PokeFloat mBankOut,8,fRelease#
	PokeFloat mBankOut,12,fThreshold#
	PokeFloat mBankOut,16,fRatio#
	PokeFloat mBankOut,20,fPredelay#
		
	iResult = BASS_FXSetParameters(iHFX,mBankOut)
	
	FreeBank mBankOut
	Return iResult
End Function

Function BASS_FXDISTORTION(iHFX, fGain#,fEdge#,fPostEQCenterFrequency#,fPostEQBandwidth#,fPreLowpassCutoff#)
	Local mBankOut,iResult
	
	mBankOut = CreateBank(4 * 5)
	PokeFloat mBankOut,0,fGain#
	PokeFloat mBankOut,4,fEdge#
	PokeFloat mBankOut,8,fPostEQCenterFrequency#
	PokeFloat mBankOut,12,fPostEQBandwidth#
	PokeFloat mBankOut,16,fPreLowpassCutoff#
		
	iResult = BASS_FXSetParameters(iHFX,mBankOut)
	
	FreeBank mBankOut
	Return iResult
End Function

Function BASS_FXECHO(iHFX, fWetDryMix#,fFeedback#,fLeftDelay#,fRightDelay#,lPanDelay)
	Local mBankOut,iResult
	
	mBankOut = CreateBank(4 * 5)
	PokeFloat mBankOut,0,fWetDryMix#
	PokeFloat mBankOut,4,fFeedback#
	PokeFloat mBankOut,8,fLeftDelay#
	PokeFloat mBankOut,12,fRightDelay#
	PokeInt   mBankOut,16,lPanDelay
		
	iResult = BASS_FXSetParameters(iHFX,mBankOut)
	
	FreeBank mBankOut
	Return iResult
End Function

Function BASS_FXFLANGER(iHFX, fWetDryMix#,fDepth#,fFeedback#,fFrequency#,iWaveform,fDelay#,iPhase)
	Local mBankOut,iResult
	
	mBankOut = CreateBank(4 * 7)
	PokeFloat mBankOut,0,fWetDryMix#
	PokeFloat mBankOut,4,fDepth#
	PokeFloat mBankOut,8,fFeedback#
	PokeFloat mBankOut,12,fFrequency#
	PokeInt   mBankOut,16,iWaveform
	PokeFloat mBankOut,20,fDelay#
	PokeInt   mBankOut,24,iPhase
		
	iResult = BASS_FXSetParameters(iHFX,mBankOut)
	
	FreeBank mBankOut
	Return iResult
End Function

Function BASS_FXGARGLE(iHFX, dwRateHz,dwWaveShape)
	Local mBankOut,iResult
	
	mBankOut = CreateBank(4 * 2)
	PokeInt mBankOut,0,dwRateHz
	PokeInt mBankOut,4,dwWaveShape
		
	iResult = BASS_FXSetParameters(iHFX,mBankOut)
	
	FreeBank mBankOut
	Return iResult
End Function

Function BASS_FXI3DL2REVERB(iHFX, lRoom,lRoomHF,flRoomRolloffFactor#,flDecayTime#,flDecayHFRatio#,lReflections,flReflectionsDelay#,lReverb,flReverbDelay#,flDiffusion#,flDensity#,flHFReference#)
	Local mBankOut,iResult
	
	mBankOut = CreateBank(4 * 12)
	PokeInt   mBankOut,0,lRoom
	PokeInt   mBankOut,4,lRoomHF
	PokeFloat mBankOut,8,flRoomRolloffFactor#
	PokeFloat mBankOut,12,flDecayTime#
	PokeFloat mBankOut,16,flDecayHFRatio#
	PokeInt   mBankOut,20,lReflections
	PokeFloat mBankOut,24,flReflectionsDelay#
	PokeInt   mBankOut,28,lReverb
	PokeFloat mBankOut,32,flReverbDelay#
	PokeFloat mBankOut,36,flDiffusion#
	PokeFloat mBankOut,40,flDensity#
	PokeFloat mBankOut,44,flHFReference#
		
	iResult = BASS_FXSetParameters(iHFX,mBankOut)
	
	FreeBank mBankOut
	Return iResult
End Function

Function BASS_FXPARAMEQ(iHFX, fCenter#,fBandwidth#,fGain#)
	Local mBankOut,iResult
	
	mBankOut = CreateBank(4 * 3)
	PokeFloat mBankOut,0,fCenter#
	PokeFloat mBankOut,4,fBandwidth#
	PokeFloat mBankOut,8,fGain#
		
	iResult = BASS_FXSetParameters(iHFX,mBankOut)
	
	FreeBank mBankOut
	Return iResult
End Function

Function BASS_FXREVERB(iHFX, fInGain#,fReverbMix#,fReverbTime#,fHighFreqRTRatio#)
	Local mBankOut,iResult
	
	mBankOut = CreateBank(4 * 4)
	PokeFloat mBankOut,0,fInGain#
	PokeFloat mBankOut,4,fReverbMix#
	PokeFloat mBankOut,8,fReverbTime#
	PokeFloat mBankOut,12,fHighFreqRTRatio#
	
	iResult = BASS_FXSetParameters(iHFX,mBankOut)
	
	FreeBank mBankOut
	Return iResult
End Function


; ----------------------------------------------------------------------------------------------
; BASS Simplification Functions
; ----------------------------------------------------------------------------------------------
Function sSIMPLIFICATION_________() : End Function

; Sets the information for a sample easier, creates the bank and plops everything in it...
Function BASS_EZSampleSetInfo(iSampleHandle,iFreq,iVolume,iPan,iFlags,iLength,iMax,iMode3D,fMinDist#,fMaxDest#,iAngle,oAngle,iOutVol,iVAM,iPri)
	Local mBankOut,iResult
	
	mBankOut = CreateBank(4 * 15)
	PokeInt mBankOut,0,iFreq
	PokeInt mBankOut,4,iVolume
	PokeInt mBankOut,8,iPan
	PokeInt mBankOut,12,iFlags
	PokeInt mBankOut,16,iLength
	PokeInt mBankOut,20,iMax
	PokeInt mBankOut,24,iMode3D
	PokeInt mBankOut,28,fMinDist#
	PokeInt mBankOut,32,fMaxDest#
	PokeInt mBankOut,36,iAngle
	PokeInt mBankOut,40,oAngle
	PokeInt mBankOut,44,iOutVol
	PokeInt mBankOut,48,iVAM
	PokeInt mBankOut,52,iPri
		
	iResult = BASS_SampleSetInfo(iSampleHandle,mBankOut)
	FreeBank mBankOut
	Return iResult
End Function

; Sets one of the presets... EG: EAX_PRESET_ARENA... The list of them are at the bottom...
Function BASS_SetEAXPreset(iPresetNum)
	Local mBankIn,iResult
	If iPresetNum >= 0 And iPresetNum <= 25
	
		mBankIn  = CreateBank(4)
		PokeInt mBankIn,0,iPresetNum

		iResult = CallDLL(sBlitzBASSDLLNameA101B6,sBlitzBASSDLLCommandPrefixA101B6 + "BASS_SetEAXPreset",mBankIn)
		
		FreeBank mBankIn
		Return iResult
	EndIf
End Function

; Returns either the handle to the sample or error code, if bFreeBank = true then the sound bank you
; pass is freed before the handle/error code is returned.
Function BASS_CreateSampleFromBank(mBankSound,iFreq,iMax,iFlags,bFreeBank = True)
	Local iResult,iReturnVal

	If BASS_SampleCreate(mBankSound,iFreq,iMax,iFlags)
		If bFreeBank = True Then FreeBank(mBankSound)
		iResult = BASS_SampleCreateDone()
		If iResult = 0
			iReturnVal = BASS_ErrorGetCode()
		Else
			iReturnVal = iResult
		EndIf
	Else 
		iReturnVal = BASS_ErrorGetCode()
	EndIf
	
	Return iReturnVal
End Function

; Gets the Major part of the version info.. 
Function BASS_GetVersionMajor()
	Return BASS_GetVersion() And $0000FFFF
End Function

; Gets the Minor part (revision?) of the version of BASS..
Function BASS_GetVersionMinor()
	Return (BASS_GetVersion() And $FFFF0000) Shr 16
End Function

;Function BASS_GetStreamTagValue$(mTagBuffer,iTagGet)
;	Return BASSPeekString(mTagBuffer)
;End Function

; Makes a long from 2 words. Usful for the version info and a few of the channel commands...
; See bass C++ examples.
Function MAKELONG(word1,word2)
	Return (word2 Shl 16) Or (word1 And $0000FFFF)
End Function


; ----------------------------------------------------------------------------------------------
; GLOBAL AND DEBUG Functions
; ----------------------------------------------------------------------------------------------
Function sGLOBAL_AND_DEBUG_____() : End Function

; Null terminated string poke... dont think blitz has a function for this?
Function BASSPokeString(mBankAddr,sStringOut$,iBufferOffset = 0)
	For n = 1 To Len(sStringOut$)
		PokeByte mBankAddr,iBufferOffset,Asc(Mid$(sStringOut$,n,1))
		iBufferOffset = iBufferOffset + 1
	Next
	PokeByte mBankAddr,iBufferOffset,0 ; Null terminate
End Function

; Null terminated string peek... dont think blitz has a function for this?
Function BASSPeekString$(mBankAddr,iBufferOffset = 0)
	Local sOutStr$ = "",iByte
	
	For n = 0 To BankSize(mBankAddr)
		iByte = PeekByte(mBankAddr,iBufferOffset)
		If iByte <> 0 
			sOutStr$ = sOutStr$ + Chr(iByte)
		Else
			Exit
		EndIf
		iBufferOffset = iBufferOffset + 1
	Next

	Return sOutStr$
End Function

; DEBUG PURPOSES ONLY!
Function BASSOutBank(sFile$,mBank)
	Local fhl
	fhl = WriteFile(sFile$)
	WriteBytes mBank,fhl,0,BankSize(mBank)
	CloseFile fhl
End Function




; ########################################################################################
;  DEFINITIONS
; ########################################################################################
Function sDEFINITIONS____________() : End Function

; Error codes returned by BASS_GetErrorCode()
Const BASS_OK             = 0 ; all is OK
Const BASS_ERROR_MEM      = 1 ; memory error
Const BASS_ERROR_FILEOPEN = 2 ; can't open the file
Const BASS_ERROR_DRIVER   = 3 ; can't find a free/valid driver
Const BASS_ERROR_BUFLOST  = 4 ; the sample buffer was lost - please report this!
Const BASS_ERROR_HANDLE   = 5 ; invalid handle
Const BASS_ERROR_FORMAT   = 6 ; unsupported format
Const BASS_ERROR_POSITION = 7 ; invalid playback position
Const BASS_ERROR_INIT     = 8 ; BASS_Init has not been successfully called
Const BASS_ERROR_START    = 9 ; BASS_Start has not been successfully called
Const BASS_ERROR_INITCD   = 10; can't initialize CD
Const BASS_ERROR_CDINIT   = 11; BASS_CDInit has not been successfully called
Const BASS_ERROR_NOCD     = 12; no CD in drive
Const BASS_ERROR_CDTRACK  = 13; can't play the selected CD track
Const BASS_ERROR_ALREADY  = 14; already initialized
Const BASS_ERROR_CDVOL    = 15; CD has no volume control
Const BASS_ERROR_NOPAUSE  = 16; not paused
Const BASS_ERROR_NOTAUDIO = 17; not an audio track
Const BASS_ERROR_NOCHAN   = 18; can't get a free channel
Const BASS_ERROR_ILLTYPE  = 19; an illegal type was specified
Const BASS_ERROR_ILLPARAM = 20; an illegal parameter was specified
Const BASS_ERROR_NO3D     = 21; no 3D support
Const BASS_ERROR_NOEAX    = 22; no EAX support
Const BASS_ERROR_DEVICE   = 23; illegal device number
Const BASS_ERROR_NOPLAY   = 24; not playing
Const BASS_ERROR_FREQ     = 25; illegal sample rate
Const BASS_ERROR_NOA3D    = 26; A3D.DLL is not installed
Const BASS_ERROR_NOTFILE  = 27; the stream is not a file stream (WAV/MP3/MP2/MP1/OGG)
Const BASS_ERROR_NOHW     = 29; no hardware voices available
Const BASS_ERROR_NOSYNC   = 30; synchronizers have been disabled
Const BASS_ERROR_EMPTY    = 31; the MOD music has no sequence data
Const BASS_ERROR_NONET    = 32; no internet connection could be opened
Const BASS_ERROR_CREATE   = 33; couldn't create the file
Const BASS_ERROR_NOFX     = 34; effects are not enabled
Const BASS_ERROR_PLAYING  = 35; the channel is playing
Const BASS_ERROR_NOOGG    = 36; OGG.DLL/VORBIS.DLL could not be loaded
Const BASS_ERROR_NOTAVAIL = 37; requested data is not available
Const BASS_ERROR_DECODE   = 38; the channel is a "decoding channel"
Const BASS_ERROR_UNKNOWN  = -1; some other mystery error

; Device setup flags
Const BASS_DEVICE_8BITS = 1  ; use 8 bit resolution, else 16 bit
Const BASS_DEVICE_MONO  = 2  ; use mono, else stereo
Const BASS_DEVICE_3D    = 4  ; enable 3D functionality
; If the BASS_DEVICE_3D flag is not specified when initilizing BASS,
; then the 3D flags (BASS_SAMPLE_3D and BASS_MUSIC_3D) are ignored when
; loading/creating a sample/stream/music.
Const BASS_DEVICE_NOSYNC   = 16  ; disable synchronizers
Const BASS_DEVICE_LEAVEVOL = 32	 ; leave the volume as it is
Const BASS_DEVICE_OGG      = 64	 ; enable OGG support (requires OGG.DLL & VORBIS.DLL)
Const BASS_DEVICE_NOTHREAD = 128 ; update buffers manually (using BASS_Update)
Const BASS_DEVICE_LATENCY  = 256 ; calculate device latency (BASS_INFO struct)

; DirectSound interfaces (for use with BASS_GetDSoundObject)
Const BASS_OBJECT_DS    = 1 ; IDirectSound
Const BASS_OBJECT_DS3DL = 2 ; IDirectSound3DListener

; BASS_INFO flags (from DSOUND.H)
Const DSCAPS_CONTINUOUSRATE = $00000010
; supports all sample rates between min/maxrate
Const DSCAPS_EMULDRIVER     = $00000020
; device does NOT have hardware DirectSound support
Const DSCAPS_CERTIFIED      = $00000040
; device driver has been certified by Microsoft
; The following flags tell what type of samples are supported by HARDWARE
; mixing, all these formats are supported by SOFTWARE mixing
Const DSCAPS_SECONDARYMONO   = $00000100 ; mono
Const DSCAPS_SECONDARYSTEREO = $00000200 ; stereo
Const DSCAPS_SECONDARY8BIT   = $00000400 ; 8 bit
Const DSCAPS_SECONDARY16BIT  = $00000800 ; 16 bit

; Music flags
Const BASS_MUSIC_RAMP      = 1       ; normal ramping
Const BASS_MUSIC_RAMPS     = 2       ; sensitive ramping
; Ramping doesn't take a lot of extra processing and improves
; the sound quality by removing "clicks". Sensitive ramping will
; leave sharp attacked samples, unlike normal ramping.
Const BASS_MUSIC_LOOP      = 4       ; loop music
Const BASS_MUSIC_FT2MOD    = 16      ; play .MOD as FastTracker 2 does
Const BASS_MUSIC_PT1MOD    = 32      ; play .MOD as ProTracker 1 does
Const BASS_MUSIC_MONO      = 64      ; force mono mixing (less CPU usage)
Const BASS_MUSIC_3D        = 128     ; enable 3D functionality
Const BASS_MUSIC_POSRESET  = 256     ; stop all notes when moving position
Const BASS_MUSIC_SURROUND  = 512     ; surround sound
Const BASS_MUSIC_SURROUND2 = 1024    ; surround sound (mode 2)
Const BASS_MUSIC_STOPBACK  = 2048    ; stop the music on a backwards jump effect
Const BASS_MUSIC_FX        = 4096    ; enable DX8 effects
Const BASS_MUSIC_CALCLEN   = 8192    ; calculate playback length
Const BASS_MUSIC_DECODE    = $200000 ; don't play the music, only decode (BASS_ChannelGetData)

Const BASS_SAMPLE_8BITS     = 1       ; 8 bit, else 16 bit
Const BASS_SAMPLE_MONO      = 2       ; mono, else stereo
Const BASS_SAMPLE_LOOP      = 4       ; looped
Const BASS_SAMPLE_3D        = 8       ; 3D functionality enabled
Const BASS_SAMPLE_SOFTWARE  = 16      ; it's NOT using hardware mixing
Const BASS_SAMPLE_MUTEMAX   = 32      ; muted at max distance (3D only)
Const BASS_SAMPLE_VAM       = 64      ; uses the DX7 voice allocation & management
Const BASS_SAMPLE_FX        = 128     ; the DX8 effects are enabled
Const BASS_SAMPLE_OVER_VOL  = $10000  ; override lowest volume
Const BASS_SAMPLE_OVER_POS  = $20000  ; override longest playing
Const BASS_SAMPLE_OVER_DIST = $30000  ; override furthest from listener (3D only)

Const BASS_MP3_HALFRATE     = $10000  ; reduced quality MP3/MP2/MP1 (half sample rate)
Const BASS_MP3_SETPOS       = $20000  ; enable pin-point seeking on the MP3/MP2/MP1/OGG

Const BASS_STREAM_AUTOFREE  = $40000  ; automatically free the stream when it stop/ends
Const BASS_STREAM_RESTRATE  = $80000  ; restrict the download rate of internet file streams
Const BASS_STREAM_BLOCK     = $100000 ; download/play internet file stream (MPx/OGG) in small blocks
Const BASS_STREAM_DECODE    = $200000 ; don't play the stream, only decode (BASS_ChannelGetData)

; DX7 voice allocation flags
Const BASS_VAM_HARDWARE = 1
Const BASS_VAM_SOFTWARE = 2

; DX7 voice management flags
Const BASS_VAM_TERM_TIME = 4
Const BASS_VAM_TERM_DIST = 8
Const BASS_VAM_TERM_PRIO = 16

; 3D channel modes
Const BASS_3DMODE_NORMAL   = 0
Const BASS_3DMODE_RELATIVE = 1
Const BASS_3DMODE_OFF      = 2

Const BASS_3DALG_DEFAULT = 0
Const BASS_3DALG_OFF     = 1
Const BASS_3DALG_FULL    = 2
Const BASS_3DALG_LIGHT   = 3

Const BASS_SYNC_MUSICPOS  = 0
Const BASS_SYNC_POS       = 0
Const BASS_SYNC_MUSICINST = 1
Const BASS_SYNC_END       = 2
Const BASS_SYNC_MUSICFX   = 3
Const BASS_SYNC_MESSAGE   = $20000000 ; FLAG: post a Windows message (instead of callback)
Const BASS_SYNC_MIXTIME   = $40000000 ; FLAG: sync at mixtime, else at playtime
Const BASS_SYNC_ONETIME   = $80000000 ; FLAG: sync only once, else continuously

; BASS_ChannelGetData flags
Const BASS_DATA_FFT512  = $80000000 ; 512 sample FFT
Const BASS_DATA_FFT1024	= $80000001 ; 1024 FFT
Const BASS_DATA_FFT2048	= $80000002 ; 2048 FFT

; BASS_StreamGetTags flags : what's returned
Const BASS_TAG_ID3   = 0 ; ID3v1 tags : 128 byte block
Const BASS_TAG_ID3V2 = 1 ; ID3v2 tags : variable length block
Const BASS_TAG_OGG   = 2 ; OGG comments : array of null-terminated strings
Const BASS_TAG_HTTP  = 3 ; HTTP headers : array of null-terminated strings
Const BASS_TAG_ICY   = 4 ; ICY headers : array of null-terminated strings

; DX8 effect types, use with BASS_ChannelSetFX()
Const BASS_FX_CHORUS      = 0   ; GUID_DSFX_STANDARD_CHORUS
Const BASS_FX_COMPRESSOR  = 1   ; GUID_DSFX_STANDARD_COMPRESSOR
Const BASS_FX_DISTORTION  = 2   ; GUID_DSFX_STANDARD_DISTORTION
Const BASS_FX_ECHO        = 3   ; GUID_DSFX_STANDARD_ECHO
Const BASS_FX_FLANGER     = 4   ; GUID_DSFX_STANDARD_FLANGER
Const BASS_FX_GARGLE      = 5   ; GUID_DSFX_STANDARD_GARGLE
Const BASS_FX_I3DL2REVERB = 6   ; GUID_DSFX_STANDARD_I3DL2REVERB
Const BASS_FX_PARAMEQ     = 7   ; GUID_DSFX_STANDARD_PARAMEQ
Const BASS_FX_REVERB      = 8   ; GUID_DSFX_WAVES_REVERB

Const BASS_FX_PHASE_NEG_180 = 0
Const BASS_FX_PHASE_NEG_90  = 1
Const BASS_FX_PHASE_ZERO    = 2
Const BASS_FX_PHASE_90      = 3
Const BASS_FX_PHASE_180     = 4

Const CDCHANNEL = 0 ; CD channel, for use with BASS_Channel functions

; BASS_CDGetID flags
Const BASS_CDID_IDENTITY = 0
Const BASS_CDID_UPC      = 1


;:: NOTE - These are wrapped. Not actually BASS values for these..

Const EAX_PRESET_GENERIC         = 0
Const EAX_PRESET_PADDEDCELL      = 1
Const EAX_PRESET_ROOM            = 2
Const EAX_PRESET_BATHROOM        = 3
Const EAX_PRESET_LIVINGROOM      = 4
Const EAX_PRESET_STONEROOM       = 5
Const EAX_PRESET_AUDITORIUM      = 6
Const EAX_PRESET_CONCERTHALL     = 7
Const EAX_PRESET_CAVE            = 8
Const EAX_PRESET_ARENA           = 9
Const EAX_PRESET_HANGAR          = 10
Const EAX_PRESET_CARPETEDHALLWAY = 11
Const EAX_PRESET_HALLWAY         = 12 
Const EAX_PRESET_STONECORRIDOR   = 13
Const EAX_PRESET_ALLEY           = 14
Const EAX_PRESET_FOREST          = 15
Const EAX_PRESET_CITY            = 16
Const EAX_PRESET_MOUNTAINS       = 17
Const EAX_PRESET_QUARRY          = 18
Const EAX_PRESET_PLAIN           = 19
Const EAX_PRESET_PARKINGLOT      = 20
Const EAX_PRESET_SEWERPIPE       = 21
Const EAX_PRESET_UNDERWATER      = 22
Const EAX_PRESET_DRUGGED         = 23
Const EAX_PRESET_DIZZY           = 24
Const EAX_PRESET_PSYCHOTIC       = 25

Const EAX_ENVIRONMENT_GENERIC         = 0
Const EAX_ENVIRONMENT_PADDEDCELL      = 1
Const EAX_ENVIRONMENT_ROOM            = 2
Const EAX_ENVIRONMENT_BATHROOM        = 3
Const EAX_ENVIRONMENT_LIVINGROOM      = 4
Const EAX_ENVIRONMENT_STONEROOM       = 5
Const EAX_ENVIRONMENT_AUDITORIUM      = 6
Const EAX_ENVIRONMENT_CONCERTHALL     = 7
Const EAX_ENVIRONMENT_CAVE            = 8
Const EAX_ENVIRONMENT_ARENA           = 9
Const EAX_ENVIRONMENT_HANGAR          = 10
Const EAX_ENVIRONMENT_CARPETEDHALLWAY = 11
Const EAX_ENVIRONMENT_HALLWAY         = 12 
Const EAX_ENVIRONMENT_STONECORRIDOR   = 13
Const EAX_ENVIRONMENT_ALLEY           = 14
Const EAX_ENVIRONMENT_FOREST          = 15
Const EAX_ENVIRONMENT_CITY            = 16
Const EAX_ENVIRONMENT_MOUNTAINS       = 17
Const EAX_ENVIRONMENT_QUARRY          = 18
Const EAX_ENVIRONMENT_PLAIN           = 19
Const EAX_ENVIRONMENT_PARKINGLOT      = 20
Const EAX_ENVIRONMENT_SEWERPIPE       = 21
Const EAX_ENVIRONMENT_UNDERWATER      = 22
Const EAX_ENVIRONMENT_DRUGGED         = 23
Const EAX_ENVIRONMENT_DIZZY           = 24
Const EAX_ENVIRONMENT_PSYCHOTIC       = 25

; Originals..

; EAX presets, usage: BASS_SetEAXParameters(EAX_PRESET_xxx)
;Const EAX_PRESET_GENERIC         EAX_ENVIRONMENT_GENERIC,0.5F,1.493F,0.5F
;Const EAX_PRESET_PADDEDCELL      EAX_ENVIRONMENT_PADDEDCELL,0.25F,0.1F,0.0F
;Const EAX_PRESET_ROOM            EAX_ENVIRONMENT_ROOM,0.417F,0.4F,0.666F
;Const EAX_PRESET_BATHROOM        EAX_ENVIRONMENT_BATHROOM,0.653F,1.499F,0.166F
;Const EAX_PRESET_LIVINGROOM      EAX_ENVIRONMENT_LIVINGROOM,0.208F,0.478F,0.0F
;Const EAX_PRESET_STONEROOM       EAX_ENVIRONMENT_STONEROOM,0.5F,2.309F,0.888F
;Const EAX_PRESET_AUDITORIUM      EAX_ENVIRONMENT_AUDITORIUM,0.403F,4.279F,0.5F
;Const EAX_PRESET_CONCERTHALL     EAX_ENVIRONMENT_CONCERTHALL,0.5F,3.961F,0.5F
;Const EAX_PRESET_CAVE            EAX_ENVIRONMENT_CAVE,0.5F,2.886F,1.304F
;Const EAX_PRESET_ARENA           EAX_ENVIRONMENT_ARENA,0.361F,7.284F,0.332F
;Const EAX_PRESET_HANGAR          EAX_ENVIRONMENT_HANGAR,0.5F,10.0F,0.3F
;Const EAX_PRESET_CARPETEDHALLWAY EAX_ENVIRONMENT_CARPETEDHALLWAY,0.153F,0.259F,2.0F
;Const EAX_PRESET_HALLWAY         EAX_ENVIRONMENT_HALLWAY,0.361F,1.493F,0.0F
;Const EAX_PRESET_STONECORRIDOR   EAX_ENVIRONMENT_STONECORRIDOR,0.444F,2.697F,0.638F
;Const EAX_PRESET_ALLEY           EAX_ENVIRONMENT_ALLEY,0.25F,1.752F,0.776F
;Const EAX_PRESET_FOREST          EAX_ENVIRONMENT_FOREST,0.111F,3.145F,0.472F
;Const EAX_PRESET_CITY            EAX_ENVIRONMENT_CITY,0.111F,2.767F,0.224F
;Const EAX_PRESET_MOUNTAINS       EAX_ENVIRONMENT_MOUNTAINS,0.194F,7.841F,0.472F
;Const EAX_PRESET_QUARRY          EAX_ENVIRONMENT_QUARRY,1.0F,1.499F,0.5F
;Const EAX_PRESET_PLAIN           EAX_ENVIRONMENT_PLAIN,0.097F,2.767F,0.224F
;Const EAX_PRESET_PARKINGLOT      EAX_ENVIRONMENT_PARKINGLOT,0.208F,1.652F,1.5F
;Const EAX_PRESET_SEWERPIPE       EAX_ENVIRONMENT_SEWERPIPE,0.652F,2.886F,0.25F
;Const EAX_PRESET_UNDERWATER      EAX_ENVIRONMENT_UNDERWATER,1.0F,1.499F,0.0F
;Const EAX_PRESET_DRUGGED         EAX_ENVIRONMENT_DRUGGED,0.875F,8.392F,1.388F
;Const EAX_PRESET_DIZZY           EAX_ENVIRONMENT_DIZZY,0.139F,17.234F,0.666F
;Const EAX_PRESET_PSYCHOTIC       EAX_ENVIRONMENT_PSYCHOTIC,0.486F,7.563F,0.806F